Set Implicit Arguments.
Require Import MyTactics.
Require Import DeBruijn.
Require Import Environments.
Require Import Syntax.
Require Import WkInversion.
Require Import Resources.
Require Import Typing.
Require Import JBasic.
Require Import Top.
Require Import JSubstitution.
Require Import JctopInduction.

(* Lemmas about the elimination of the universal quantifier. *)

(* These are neither classification nor decomposition lemmas, so we place them
   in a separate file. *)

Lemma instantiation_TyForall_PERM:
  forall R K kappa P,
  jpi R K (TyForall kappa P) ->
  forall U,
  wk K U kappa ->
  jpi R K (subst U 0 P).
Proof.
  intros.
  forwards: jpi_substitutable; [ eauto | ].
  jpi_inversion.
  eapply j_substitution; eauto.
Qed.

Lemma instantiation_TyForall_TYPE:
  forall R K v kappa T,
  jctop R K v (TyForall kappa T) ->
  forall U,
  wk K U kappa ->
  jctop R K v (subst U 0 T).
Proof.
  jctop_induction.
  (* JCut *)
  solve [ eauto 4 using JcTopSameResource with j aac ].
  (* JForallIntro *)
  econstructor.
    eauto.
    eapply j_substitution; eauto using jpi_substitutable with subst_lift.
    eauto using instantiation_TyForall_PERM.
    eauto.
Qed.

