Set Implicit Arguments.
Require Import Omega.

(* Basic arithmetic facts. *)

Lemma eq_lt_lt_1:
  forall l m n,
  l < m ->
  n = m ->
  l < n.
Proof.
  intros. subst. assumption.
Qed.

Lemma eq_lt_lt_2:
  forall l m n,
  l < m ->
  m = n ->
  l < n.
Proof.
  intros. subst. assumption.
Qed.

Lemma ge_lt_lt:
  forall l m n,
  l < m ->
  m <= n ->
  l < n.
Proof.
  intros. omega.
Qed.

Hint Resolve eq_lt_lt_1 eq_lt_lt_2 ge_lt_lt : lt_lt.

