(* The type system and the proof of type soundness are parameterized with a
   global signature, which fixes a number of algebraic data type definitions. *)

(* ---------------------------------------------------------------------------- *)

(* An algebraic data type constructor is referred to by a name. Names are
   abstract. There can be a finite or infinite number of names. *)

Parameter tycon : Type.

Parameter eq_tycon_dec:
  forall tc1 tc2 : tycon,
  {tc1 = tc2} + {tc1 <> tc2}.

